#include <stdio.h>
#include <stdlib.h>
#include <string.h>

unsigned long gethex(char *p, int n) {
	char c;
	int i;
	unsigned long v = 0;
	for (i=0; i<n; i++) {
		c = *p++;
		v <<= 4;
		if (c >= '0' && c <= '9') {
			v += (c - '0');
		} else if (c >= 'A' && c <= 'F') {
			v += (c - 'A' + 10);
		} else if (c >= 'a' && c <= 'a') {
			v += (c - 'a' + 10);
		} else {
			return 0xffffffff;
		}
	}
	return v;
}

int main(int argc, char **argv) {
	FILE *fp;
	unsigned char *buf;
	long siz, rsiz;
	int warn;
	char lbuf[1024];
	char *p;

	if (argc != 3) {
		fprintf(stderr, "g: BFC <pb`𓖂Ăt@C> <t@C>\n\n"
				"    'fc /b <t@C> <Vt@C>' `̍t@C\n"
				"    oCipb`ƂēKp܂B\n");
		return -1;
	}

	/* pb`đΏۃt@CSǂݍ */
	fp = fopen(argv[1], "rb");
	if (fp == NULL) {
		fprintf(stderr, "'%s'ǂݍ߂܂\n", argv[1]);
		return -1;
	}
	fseek(fp, 0, SEEK_END);
	siz = ftell(fp);
	fseek(fp, 0, SEEK_SET);
	buf = malloc(siz);
	if (buf == NULL) {
		fclose(fp);
		fprintf(stderr, "mۂł܂\n");
		return -1;
	}
	rsiz = fread(buf, 1, siz, fp);
	fclose(fp);
	if (rsiz != siz) {
		free(buf);
		fprintf(stderr, "'%s'̓ǂݍݒɃG[܂\n", argv[1]);
		return -1;
	}

	/* t@CI[v */
	fp = fopen(argv[2], "r");
	if (fp == NULL) {
		fprintf(stderr, "'%s'ǂݍ߂܂\n", argv[2]);
		return -1;
	}
	warn = 0;
	while (fgets(lbuf, 1024, fp) != NULL) {
		unsigned long va, v0, v1;
		va = gethex(&lbuf[0], 8);
		if (va == 0xffffffff) continue;
		if (lbuf[8] != ':') continue;
		if (lbuf[9] != ' ') continue;
		v0 = gethex(&lbuf[10], 2);
		if (v0 == 0xffffffff) continue;
		if (lbuf[12] != ' ') continue;
		v1 = gethex(&lbuf[13], 2);
		if (v1 == 0xffffffff) continue;

		if (buf[va] != (unsigned char)v0) {
			fprintf(stderr, "x: ItZbg %08X  %02X ł͂܂\n", va, v0);
			warn = 1;
		}
		buf[va] = v1;
	}
	fclose(fp);

	if (warn) {
		fprintf(stdout, "Ώۂ̃t@Cɍق܂Bpb`𓖂Ă܂? [y/n] ");
		if (getchar() != 'y') goto xit;
	}

	/* ʂo */
	p = strrchr(argv[1], '.');
	if (p == NULL) {
		strcpy(lbuf, argv[1]);
		strcat(lbuf, "_patched");
	} else {
		int l;
		l = p - argv[1];
		strncpy(lbuf, argv[1], l);
		strcpy(&lbuf[l], "_patched");
		strcpy(&lbuf[l+8], p);
	}
	fp = fopen(lbuf, "wb");
	rsiz = fwrite(buf, 1, siz, fp);
	fclose(fp);
	if (rsiz != siz) {
		free(buf);
		fprintf(stderr, "'%s'̏ݒɃG[܂\n", lbuf);
		return -1;
	}
	fprintf(stdout, "'%s'o͂܂\n", lbuf);
xit:
	free(buf);
	return 0;
}

